<?php  

/*
Plugin Name: Empty Widget Area
Description: Easily empty/truncate a widget area
Plugin URI: http://tormorten.no
Author: Tor Morten Jensen/Smart Media AS
Author URI: http://tormorten.no
Version: 1.0
License: GPL2
Text Domain: ewa
Domain Path: languages/
*/

/*

    Copyright (C) 2014  Tor Morten Jensen/Smart Media AS  tormorten@smartmedia.no

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

add_action( 'admin_head', 'ewa_init', 0, 9999 );

function ewa_init() {
	$screen = get_current_screen();

	if($screen->base == 'widgets') {

		?>
		<script>
		jQuery(document).ready(function($) {
			$('.empty-widget-area').click(function(e) {
				e.preventDefault();

				var run = confirm('<?php _e('Are you sure you want to do this? (this action can not be undone)', 'ewa'); ?>'),
					_self = $(this),
					_parent = _self.parent().parent().parent(),
					widgets = _parent.find('.widget');

				if( run == true ) {
					
					var index = _self.data('index');

					$.post(ajaxurl, { action: 'ewa_truncate', index: index }, function(response) {
						if( response.deleted == true ) {
							console.log(widgets.length);

							widgets.fadeOut('slow', function() {
								$(this).remove();
								_self.remove();
							});

						}
					});

				}



			});
		});
		</script>
		<?php

	}
}

add_action( 'dynamic_sidebar_before', 'ewa_add_deleter' );

function ewa_add_deleter( $index ) {

	if( is_admin() && is_active_sidebar( $index ) ) {
		echo '<div class="submitbox alignright">';
		echo '<p><a class="empty-widget-area submitdelete" href="#" data-index="'. $index .'">'. __( 'Empty Widget Area', 'ewa' ) .'</a></p>';
		echo '</div>';
		echo '<div style="clear:both;"></div>';
	}

}

add_action( 'wp_ajax_ewa_truncate', 'ewa_truncate' );

function ewa_truncate() {

	$index = $_POST['index'];

	$sidebars = get_option( 'sidebars_widgets', array() );

	// only do the update if our index is set and is not empty
	if(isset($sidebars[$index]) && !empty($sidebars[$index])) {
		$sidebars[$index] = array();
		update_option( 'sidebars_widgets', $sidebars );
	}

	wp_send_json( array( 'deleted' => true ) );

	die;

}


?>